#include "registry.h"

long ReadRegStr(char * output, DWORD output_size, HKEY rootkey, const char * subkey, const char * name)
{
    long returnStatus;
    HKEY hKey;
    DWORD dwType = REG_SZ;

    returnStatus = RegOpenKeyEx(rootkey, subkey, 0L, KEY_QUERY_VALUE, &hKey);
    if (returnStatus == ERROR_SUCCESS) {
        returnStatus = RegQueryValueExA(hKey, name, NULL, &dwType, (LPBYTE)output, &output_size);
    }
    RegCloseKey(hKey);

    return returnStatus;
}

long WriteRegStr(HKEY rootkey, const char * subkey, const char * name, const char * value)
{
    HKEY hKey;
    long returnStatus;

    returnStatus = RegCreateKeyEx(rootkey, subkey, 0L, NULL, REG_OPTION_NON_VOLATILE, KEY_SET_VALUE, NULL, &hKey, NULL);
    if (returnStatus == ERROR_SUCCESS) {
         returnStatus = RegSetValueEx(hKey, name, 0, REG_SZ, value, strlen(value) + 1);
    }
    RegCloseKey(hKey);

    return returnStatus;
}

long DeleteRegValue(HKEY rootkey, const char * subkey, const char * name)
{
    HKEY hKey;
    long returnStatus;

    returnStatus = RegOpenKeyEx(rootkey, subkey, 0L, KEY_SET_VALUE, &hKey);
    if (returnStatus == ERROR_SUCCESS) {
         returnStatus = RegDeleteValue(hKey, name);
    }
    RegCloseKey(hKey);

    return returnStatus;

}
