/*
 * OS-specific functions
 */

#ifndef SHELL_H
#define SHELL_H

#include <stdio.h>
#include <windows.h>
#include "registry.h"

#define PROCESS_CONTINUE 0
#define PROCESS_ABORT    1

DWORD ExecWait(char * commandLine);

long GetCurrentWallpaper(char * filename, int max_length);
long GetExeDirectory(char * filename, int max_length);
long GetExeFilename(char * filename, int max_length);
long ConvertJpgToBmp(const char * filename, char * converted_filename);
long SetWallpaper(const char * filename, BOOL convertToBmp);

BOOL RegisterStartup(char * program_name, char *exe_filename, BOOL allUsers);
BOOL UnregisterStartup(char * program_name, BOOL allUsers);
BOOL IsRegistered(char * program_name, char * exe_filename);

#endif // SHELL_H
